/*
 * IBM SupportPac MA0K
 * WebSphere MQ Completion Code and Reason Code analysis programs V1.4
 * http://www.ibm.com/support/docview.wss?uid=swg24000652
 *
 * MQCM - 'WebSphere MQ' Code to Message conversion functions
 *
 * "mqcmh.h" C/C++ header module for constants and function prototypes in "mqcm.c"
 *
 * Source file: \\IBM-L3V1408\WMQ-PROJ\MA0K-v1.4-Build\_Source\mqcmh-11.c
 *
 * Environments: Windows 32 bit, Unix (AIX, HP-UX, Solaris, Linux), z/OS
 *
 * Revision History
 * ================
 * Version  Date         Author    Changes
 *     1.1  20 Apr 1999  Glenn     Initial version for MQSeries 5.0
 *                       Baddeley <glenbadd@au1.ibm.com>
 *       2  14 Feb 2000  GB        Updated for MQSeries 5.1 using
 *                                 cmqc.h supplied for HP-UX.
 *       3  22 Nov 2000  GB        Updated for MQSeries 5.2 using
 *                                 cmqc.h supplied for NT.
 *       4  15 Feb 2001  GB        Add MQCM_RC6 symbols for mqcm.c v6
 *       8  11 Jul 2002  GB        Update version to same as mqcm.c,
 *                                 Increase MQCM_RCMAX for MQ 5.3,
 *                                 Delete 'OFFSET' defines as they are
 *                                 just the -ve of 'MIN' defines,
 *                                 Add MQCM_MINRETSTRSIZE
 *       9  28 Jan 2004  GB        Change copyright owner from IBM GSA
 *                                 to IBM Australia
 *      10  25 Oct 2005  GB        Update MQCM_RCMAX for WMQ 6.0 
 *      11  25 Sep 2008  GB        Update MQCM_RCMAX for WMQ 7.0 GA
 *                                 Revise copyright and owner information
 */

#if defined(__cplusplus)
extern "C" {
#endif

#define MQCMH_SRCID "@(#)MQCMH.H VER=1.11 DATE=25-Sep-2008"

/*  <N_OCO_COPYRIGHT>
 *  Licensed Materials - Property of IBM
 *  (c) Copyright IBM Corp. 2008 All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *  <NOC_COPYRIGHT>                                                   */
#define MQCMH_OWNID "@(#)Licensed Materials - Property of IBM"
#define MQCMH_CPRID "@(#)Copyright 2008 Corp. All Rights Reserved"

/* Completion Code minimum and maximum */
#define MQCM_CCMIN -1L
#define MQCM_CCMAX 2L

/* Reason Code minimum and maximum */
#define MQCM_RCMIN 2001L
#define MQCM_RCMAX 2542L
#define MQCM_RC6MIN 6100L
#define MQCM_RC6MAX 6129L

/* Minimum return string size */
#define MQCM_MINRETSTRSIZE 64

/* Function prototypes */

char *MQCompCodeMsg( MQLONG Cc, char *RetStr );

char *MQReasonCodeMsg( MQLONG Rc, char *RetStr );

#if defined(__cplusplus)
 }
#endif

