Attribute VB_Name = "MQUTIL"
'
' IBM SupportPac MA0K
' WebSphere MQ Completion Code and Reason Code analysis programs V1.4
' http://www.ibm.com/support/docview.wss?uid=swg24000652
'
' MQUTIL - WebSphere MQ Utility functions in Microsoft Visual Basic 5.0
'
' "MQUTIL" Global declarations and Code module
'
' Source file: \\IBM-L3V1408\MWARE-WMQ\winutils\mqicp-v3.1\mqutil9.bas
'
' Revision History
' ================
' Version   Date         Name       Changes
'     1.1   26 Jun 1998  Glenn      Initial version contains CcMsg and RcMsg
'                        Baddeley   functions for CMQB3C.BAS version 2
'                        <glenbadd@au1.ibm.com>  release 0.1 of SupportPac MA04.
'       2   21 Jan 1999  GB         Regenerate for new CMQB3C.BAS version 1
'                                   release 5, updated 18 Jan 1999.
'                                   Add MQU_ prefix to function names.
'                                   Add MQU_RcAdd feature.
'       3   24 Aug 1999  GB         Support for VB 5.0
'       4   6  Dec 2000  GB         Update for MQSeries 5.2 using
'                                   cmqc.h supplied for Windows NT,
'                                   Rename functions and tidy up code
'       5   2  Mar 2001  GB         Add 6100-6129 Reason Codes for MQSeries 5.2 C++
'       6   11 Jul 2002  GB         Add Reason Codes 2362-2402 for WebSphere MQ 5.3
'       7   28 Jan 2004  GB         Change owner from IBM GSA to IBM Australia
'       8   10 Mar 2004  GB         Add Reason Codes 2187-2190, 2232, 2266-2279.
'                                   These were new in MQ 5.1 but weren't added in
'                                   version 1.2 of this module.
'                                   Change 2120 "TRUNCATED" to "CONVERTED_MSG_TOO_BIG"
'                                   to match WMQ manual.
'       9   29 Sep 2008  GB         Updated for WMQ 6.0 to add 2210 - 2212,
'                                   2228 - 2229, 2395, 2406 - 2423
'                                   Updated for MQ 7.0 GA to add 2200, 2372,
'                                   2408, 2424 - 2542
'
Private Const SRCID = "@(#)MQUTIL9.BAS VER=1.9 DATE=29-Sep-2008"

' <N_OCO_COPYRIGHT>
' Licensed Materials - Property of IBM
' (c) Copyright IBM Corp. 2008 All Rights Reserved.
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
' <NOC_COPYRIGHT>
Private Const CPRID = "@(#)Copyright 2004 IBM Australia"
Private Const OWNID = "@(#)Licensed Materials - Property of IBM"

Option Explicit

Const NUMPFX = "("
Const DESCPFX = ")"

Dim MoreRc As String

Function MQCompCodeMsg(Cc As Long) As String

Dim Msg As String

  Select Case Cc
    Case 0: Msg = "OK"
    Case 1: Msg = "WARNING"
    Case 2: Msg = "FAILED"
    Case -1: Msg = "UNKNOWN"
    Case Else: Msg = Cc & "_UNDEFINED"
  End Select

  MQCompCodeMsg = "MQCC_" & Msg

End Function

Sub MQReasonCodeAdd(ByVal RcNum As Long, ByVal RcDesc As String)

    If RcNum Then
        MoreRc = MoreRc & NUMPFX & RcNum & DESCPFX & RcDesc  ' Add to list
    Else
        MoreRc = ""  ' Initialise if Rc 0
    End If
    
End Sub

Function MQReasonCodeMsg(Rc As Long) As String

Dim BegNumPos As Integer, BegDescPos As Integer, EndDescPos As Integer
Dim Msg As String

  Select Case Rc
    Case 0: Msg = "NONE"

    Case 2001: Msg = "ALIAS_BASE_Q_TYPE_ERROR"
    Case 2002: Msg = "ALREADY_CONNECTED"
    Case 2003: Msg = "BACKED_OUT"
    Case 2004: Msg = "BUFFER_ERROR"
    Case 2005: Msg = "BUFFER_LENGTH_ERROR"
    Case 2006: Msg = "CHAR_ATTR_LENGTH_ERROR"
    Case 2007: Msg = "CHAR_ATTRS_ERROR"
    Case 2008: Msg = "CHAR_ATTRS_TOO_SHORT"
    Case 2009: Msg = "CONNECTION_BROKEN"
    Case 2010: Msg = "DATA_LENGTH_ERROR"
    Case 2011: Msg = "DYNAMIC_Q_NAME_ERROR"
    Case 2012: Msg = "ENVIRONMENT_ERROR"
    Case 2013: Msg = "EXPIRY_ERROR"
    Case 2014: Msg = "FEEDBACK_ERROR"
    '    2015 not defined
    Case 2016: Msg = "GET_INHIBITED"
    Case 2017: Msg = "HANDLE_NOT_AVAILABLE"
    Case 2018: Msg = "HCONN_ERROR"
    Case 2019: Msg = "HOBJ_ERROR"
    Case 2020: Msg = "INHIBIT_VALUE_ERROR"
    Case 2021: Msg = "INT_ATTR_COUNT_ERROR"
    Case 2022: Msg = "INT_ATTR_COUNT_TOO_SMALL"
    Case 2023: Msg = "INT_ATTRS_ARRAY_ERROR"
    Case 2024: Msg = "SYNCPOINT_LIMIT_REACHED"
    Case 2025: Msg = "MAX_CONNS_LIMIT_REACHED"
    Case 2026: Msg = "MD_ERROR"
    Case 2027: Msg = "MISSING_REPLY_TO_Q"
    '    2028 not defined
    Case 2029: Msg = "MSG_TYPE_ERROR"
    Case 2030: Msg = "MSG_TOO_BIG_FOR_Q"
    Case 2031: Msg = "MSG_TOO_BIG_FOR_Q_MGR"
    '    2032 not defined
    Case 2033: Msg = "NO_MSG_AVAILABLE"
    Case 2034: Msg = "NO_MSG_UNDER_CURSOR"
    Case 2035: Msg = "NOT_AUTHORIZED"
    Case 2036: Msg = "NOT_OPEN_FOR_BROWSE"
    Case 2037: Msg = "NOT_OPEN_FOR_INPUT"
    Case 2038: Msg = "NOT_OPEN_FOR_INQUIRE"
    Case 2039: Msg = "NOT_OPEN_FOR_OUTPUT"
    Case 2040: Msg = "NOT_OPEN_FOR_SET"
    Case 2041: Msg = "OBJECT_CHANGED"
    Case 2042: Msg = "OBJECT_IN_USE"
    Case 2043: Msg = "OBJECT_TYPE_ERROR"
    Case 2044: Msg = "OD_ERROR"
    Case 2045: Msg = "OPTION_NOT_VALID_FOR_TYPE"
    Case 2046: Msg = "OPTIONS_ERROR"
    Case 2047: Msg = "PERSISTENCE_ERROR"
    Case 2048: Msg = "PERSISTENT_NOT_ALLOWED"
    Case 2049: Msg = "PRIORITY_EXCEEDS_MAXIMUM"
    Case 2050: Msg = "PRIORITY_ERROR"
    Case 2051: Msg = "PUT_INHIBITED"
    Case 2052: Msg = "Q_DELETED"
    Case 2053: Msg = "Q_FULL"
    '    2054 not defined
    Case 2055: Msg = "Q_NOT_EMPTY"
    Case 2056: Msg = "Q_SPACE_NOT_AVAILABLE"
    Case 2057: Msg = "Q_TYPE_ERROR"
    Case 2058: Msg = "Q_MGR_NAME_ERROR"
    Case 2059: Msg = "Q_MGR_NOT_AVAILABLE"
    '    2060 not defined
    Case 2061: Msg = "REPORT_OPTIONS_ERROR"
    Case 2062: Msg = "SECOND_MARK_NOT_ALLOWED"
    Case 2063: Msg = "SECURITY_ERROR"
    '    2064 not defined
    Case 2065: Msg = "SELECTOR_COUNT_ERROR"
    Case 2066: Msg = "SELECTOR_LIMIT_EXCEEDED"
    Case 2067: Msg = "SELECTOR_ERROR"
    Case 2068: Msg = "SELECTOR_NOT_FOR_TYPE"
    Case 2069: Msg = "SIGNAL_OUTSTANDING"
    Case 2070: Msg = "SIGNAL_REQUEST_ACCEPTED"
    Case 2071: Msg = "STORAGE_NOT_AVAILABLE"
    Case 2072: Msg = "SYNCPOINT_NOT_AVAILABLE"
    '    2073 - 2074 not defined
    Case 2075: Msg = "TRIGGER_CONTROL_ERROR"
    Case 2076: Msg = "TRIGGER_DEPTH_ERROR"
    Case 2077: Msg = "TRIGGER_MSG_PRIORITY_ERR"
    Case 2078: Msg = "TRIGGER_TYPE_ERROR"
    Case 2079: Msg = "TRUNCATED_MSG_ACCEPTED"
    Case 2080: Msg = "TRUNCATED_MSG_FAILED"
    '    2081 not defined
    Case 2082: Msg = "UNKNOWN_ALIAS_BASE_Q"
    '    2083 - 2084 not defined
    Case 2085: Msg = "UNKNOWN_OBJECT_NAME"
    Case 2086: Msg = "UNKNOWN_OBJECT_Q_MGR"
    Case 2087: Msg = "UNKNOWN_REMOTE_Q_MGR"
    '    2088 - 2089 not defined
    Case 2090: Msg = "WAIT_INTERVAL_ERROR"
    Case 2091: Msg = "XMIT_Q_TYPE_ERROR"
    Case 2092: Msg = "XMIT_Q_USAGE_ERROR"
    Case 2093: Msg = "NOT_OPEN_FOR_PASS_ALL"
    Case 2094: Msg = "NOT_OPEN_FOR_PASS_IDENT"
    Case 2095: Msg = "NOT_OPEN_FOR_SET_ALL"
    Case 2096: Msg = "NOT_OPEN_FOR_SET_IDENT"
    Case 2097: Msg = "CONTEXT_HANDLE_ERROR"
    Case 2098: Msg = "CONTEXT_NOT_AVAILABLE"
    Case 2099: Msg = "SIGNAL1_ERROR"
    Case 2100: Msg = "OBJECT_ALREADY_EXISTS"
    Case 2101: Msg = "OBJECT_DAMAGED"
    Case 2102: Msg = "RESOURCE_PROBLEM"
    Case 2103: Msg = "ANOTHER_Q_MGR_CONNECTED"
    Case 2104: Msg = "UNKNOWN_REPORT_OPTION"
    Case 2105: Msg = "STORAGE_CLASS_ERROR"
    Case 2106: Msg = "COD_NOT_VALID_FOR_XCF_Q"
    Case 2107: Msg = "XWAIT_CANCELED"
    Case 2108: Msg = "XWAIT_ERROR"
    Case 2109: Msg = "SUPPRESSED_BY_EXIT"
    Case 2110: Msg = "FORMAT_ERROR"
    Case 2111: Msg = "SOURCE_CCSID_ERROR"
    Case 2112: Msg = "SOURCE_INTEGER_ENC_ERROR"
    Case 2113: Msg = "SOURCE_DECIMAL_ENC_ERROR"
    Case 2114: Msg = "SOURCE_FLOAT_ENC_ERROR"
    Case 2115: Msg = "TARGET_CCSID_ERROR"
    Case 2116: Msg = "TARGET_INTEGER_ENC_ERROR"
    Case 2117: Msg = "TARGET_DECIMAL_ENC_ERROR"
    Case 2118: Msg = "TARGET_FLOAT_ENC_ERROR"
    Case 2119: Msg = "NOT_CONVERTED"
    Case 2120: Msg = "CONVERTED_MSG_TOO_BIG"        ' Also TRUNCATED
    Case 2121: Msg = "NO_EXTERNAL_PARTICIPANTS"
    Case 2122: Msg = "PARTICIPANT_NOT_AVAILABLE"
    Case 2123: Msg = "OUTCOME_MIXED"
    Case 2124: Msg = "OUTCOME_PENDING"
    Case 2125: Msg = "BRIDGE_STARTED"
    Case 2126: Msg = "BRIDGE_STOPPED"
    Case 2127: Msg = "ADAPTER_STORAGE_SHORTAGE"
    Case 2128: Msg = "UOW_IN_PROGRESS"
    Case 2129: Msg = "ADAPTER_CONN_LOAD_ERROR"
    Case 2130: Msg = "ADAPTER_SERV_LOAD_ERROR"
    Case 2131: Msg = "ADAPTER_DEFS_ERROR"
    Case 2132: Msg = "ADAPTER_DEFS_LOAD_ERROR"
    Case 2133: Msg = "ADAPTER_CONV_LOAD_ERROR"
    Case 2134: Msg = "BO_ERROR"
    Case 2135: Msg = "DH_ERROR"
    Case 2136: Msg = "MULTIPLE_REASONS"
    Case 2137: Msg = "OPEN_FAILED"
    Case 2138: Msg = "ADAPTER_DISC_LOAD_ERROR"
    Case 2139: Msg = "CNO_ERROR"
    Case 2140: Msg = "CICS_WAIT_FAILED"
    Case 2141: Msg = "DLH_ERROR"
    Case 2142: Msg = "HEADER_ERROR"
    Case 2143: Msg = "SOURCE_LENGTH_ERROR"
    Case 2144: Msg = "TARGET_LENGTH_ERROR"
    Case 2145: Msg = "SOURCE_BUFFER_ERROR"
    Case 2146: Msg = "TARGET_BUFFER_ERROR"
    '    2147 not defined
    Case 2148: Msg = "IIH_ERROR"
    Case 2149: Msg = "PCF_ERROR"
    Case 2150: Msg = "DBCS_ERROR"
    '    2151 not defined
    Case 2152: Msg = "OBJECT_NAME_ERROR"
    Case 2153: Msg = "OBJECT_Q_MGR_NAME_ERROR"
    Case 2154: Msg = "RECS_PRESENT_ERROR"
    Case 2155: Msg = "OBJECT_RECORDS_ERROR"
    Case 2156: Msg = "RESPONSE_RECORDS_ERROR"
    Case 2157: Msg = "ASID_MISMATCH"
    Case 2158: Msg = "PMO_RECORD_FLAGS_ERROR"
    Case 2159: Msg = "PUT_MSG_RECORDS_ERROR"
    Case 2160: Msg = "CONN_ID_IN_USE"
    Case 2161: Msg = "Q_MGR_QUIESCING"
    Case 2162: Msg = "Q_MGR_STOPPING"
    Case 2163: Msg = "DUPLICATE_RECOV_COORD"
    '    2164 - 2172 not defined
    Case 2173: Msg = "PMO_ERROR"
    '    2174 - 2181 not defined
    Case 2182: Msg = "API_EXIT_NOT_FOUND"
    Case 2183: Msg = "API_EXIT_LOAD_ERROR"
    Case 2184: Msg = "REMOTE_Q_NAME_ERROR"
    Case 2185: Msg = "INCONSISTENT_PERSISTENCE"
    Case 2186: Msg = "GMO_ERROR"
    Case 2187: Msg = "CICS_BRIDGE_RESTRICTION"      ' 2187 - 2190 new for MQ 5.1
    Case 2188: Msg = "STOPPED_BY_CLUSTER_EXIT"
    Case 2189: Msg = "CLUSTER_RESOLUTION_ERROR"
    Case 2190: Msg = "CONVERTED_STRING_TOO_BIG"
    Case 2191: Msg = "TMC_ERROR"
    Case 2192: Msg = "STORAGE_MEDIUM_FULL"          ' Also PAGESET_FULL on S/390
    Case 2193: Msg = "PAGESET_ERROR"
    Case 2194: Msg = "NAME_NOT_VALID_FOR_TYPE"
    Case 2195: Msg = "UNEXPECTED_ERROR"
    Case 2196: Msg = "UNKNOWN_XMIT_Q"
    Case 2197: Msg = "UNKNOWN_DEF_XMIT_Q"
    Case 2198: Msg = "DEF_XMIT_Q_TYPE_ERROR"
    Case 2199: Msg = "DEF_XMIT_Q_USAGE_ERROR"
    Case 2200: Msg = "MSG_MARKED_BROWSE_CO_OP"      ' 2200, new for MQ 7.0
    Case 2201: Msg = "NAME_IN_USE"
    Case 2202: Msg = "CONNECTION_QUIESCING"
    Case 2203: Msg = "CONNECTION_STOPPING"
    Case 2204: Msg = "ADAPTER_NOT_AVAILABLE"
    '    2205 not defined
    Case 2206: Msg = "MSG_ID_ERROR"
    Case 2207: Msg = "CORREL_ID_ERROR"
    Case 2208: Msg = "FILE_SYSTEM_ERROR"
    Case 2209: Msg = "NO_MSG_LOCKED"
    Case 2210: Msg = "SOAP_DOTNET_ERROR"          '  2210 - 2212 new for MQ 6.0
    Case 2211: Msg = "SOAP_AXIS_ERROR"
    Case 2212: Msg = "SOAP_URL_ERROR"
    '    2213 - 2215 not defined
    Case 2216: Msg = "FILE_NOT_AUDITED"
    Case 2217: Msg = "CONNECTION_NOT_AUTHORIZED"
    Case 2218: Msg = "MSG_TOO_BIG_FOR_CHANNEL"
    Case 2219: Msg = "CALL_IN_PROGRESS"
    Case 2220: Msg = "RMH_ERROR"
    '    2221 not defined
    Case 2222: Msg = "Q_MGR_ACTIVE"
    Case 2223: Msg = "Q_MGR_NOT_ACTIVE"
    Case 2224: Msg = "Q_DEPTH_HIGH"
    Case 2225: Msg = "Q_DEPTH_LOW"
    Case 2226: Msg = "Q_SERVICE_INTERVAL_HIGH"
    Case 2227: Msg = "Q_SERVICE_INTERVAL_OK"
    Case 2228: Msg = "RFH_HEADER_FIELD_ERROR"     ' 2228 - 2229 new for MQ 6.0
    Case 2229: Msg = "RAS_PROPERTY_ERROR"
    '    2230 - 2231 not defined
    Case 2232: Msg = "UNIT_OF_WORK_NOT_STARTED"       ' New for MQ 5.1
    Case 2233: Msg = "CHANNEL_AUTO_DEF_OK"
    Case 2234: Msg = "CHANNEL_AUTO_DEF_ERROR"
    Case 2235: Msg = "CFH_ERROR"
    Case 2236: Msg = "CFIL_ERROR"
    Case 2237: Msg = "CFIN_ERROR"
    Case 2238: Msg = "CFSL_ERROR"
    Case 2239: Msg = "CFST_ERROR"
    '    2240 not defined
    Case 2241: Msg = "INCOMPLETE_GROUP"
    Case 2242: Msg = "INCOMPLETE_MESSAGE"
    Case 2243: Msg = "INCONSISTENT_CCSIDS"
    Case 2244: Msg = "INCONSISTENT_ENCODING"
    Case 2245: Msg = "INCONSISTENT_UOW"
    Case 2246: Msg = "INVALID_MSG_UNDER_CURSOR"
    Case 2247: Msg = "MATCH_OPTIONS_ERROR"
    Case 2248: Msg = "MDE_ERROR"
    Case 2249: Msg = "MSG_FLAGS_ERROR"
    Case 2250: Msg = "MSG_SEQ_NUMBER_ERROR"
    Case 2251: Msg = "OFFSET_ERROR"
    Case 2252: Msg = "ORIGINAL_LENGTH_ERROR"
    Case 2253: Msg = "SEGMENT_LENGTH_ZERO"
    '    2254 not defined
    Case 2255: Msg = "UOW_NOT_AVAILABLE"
    Case 2256: Msg = "WRONG_GMO_VERSION"
    Case 2257: Msg = "WRONG_MD_VERSION"
    Case 2258: Msg = "GROUP_ID_ERROR"
    Case 2259: Msg = "INCONSISTENT_BROWSE"
    Case 2260: Msg = "XQH_ERROR"
    Case 2261: Msg = "SRC_ENV_ERROR"
    Case 2262: Msg = "SRC_NAME_ERROR"
    Case 2263: Msg = "DEST_ENV_ERROR"
    Case 2264: Msg = "DEST_NAME_ERROR"
    Case 2265: Msg = "TM_ERROR"
    Case 2266: Msg = "CLUSTER_EXIT_ERROR"       ' 2266 - 2279 new for MQ 5.1
    Case 2267: Msg = "CLUSTER_EXIT_LOAD_ERROR"
    Case 2268: Msg = "CLUSTER_PUT_INHIBITED"
    Case 2269: Msg = "CLUSTER_RESOURCE_ERROR"
    Case 2270: Msg = "NO_DESTINATIONS_AVAILABLE"
    Case 2271: Msg = "CONN_TAG_IN_USE"
    Case 2272: Msg = "PARTIALLY_CONVERTED"
    Case 2273: Msg = "CONNECTION_ERROR"
    Case 2274: Msg = "OPTION_ENVIRONMENT_ERROR"
    '    2275 - 2276 not defined
    Case 2277: Msg = "CD_ERROR"
    Case 2278: Msg = "CLIENT_CONN_ERROR"
    Case 2279: Msg = "CHANNEL_STOPPED_BY_USER"
    Case 2280: Msg = "HCONFIG_ERROR"
    Case 2281: Msg = "FUNCTION_ERROR"
    Case 2282: Msg = "CHANNEL_STARTED"
    Case 2283: Msg = "CHANNEL_STOPPED"
    Case 2284: Msg = "CHANNEL_CONV_ERROR"
    Case 2285: Msg = "SERVICE_NOT_AVAILABLE"
    Case 2286: Msg = "INITIALIZATION_FAILED"
    Case 2287: Msg = "TERMINATION_FAILED"
    Case 2288: Msg = "UNKNOWN_Q_NAME"
    Case 2289: Msg = "SERVICE_ERROR"
    Case 2290: Msg = "Q_ALREADY_EXISTS"
    Case 2291: Msg = "USER_ID_NOT_AVAILABLE"
    Case 2292: Msg = "UNKNOWN_ENTITY"
    Case 2293: Msg = "UNKNOWN_AUTH_ENTITY"
    Case 2294: Msg = "UNKNOWN_REF_OBJECT"
    Case 2295: Msg = "CHANNEL_ACTIVATED"
    Case 2296: Msg = "CHANNEL_NOT_ACTIVATED"  ' Last in MQ 2.2
    Case 2297: Msg = "UOW_CANCELED"
    Case 2298: Msg = "FUNCTION_NOT_SUPPORTED"
    Case 2299: Msg = "SELECTOR_TYPE_ERROR"
    Case 2300: Msg = "COMMAND_TYPE_ERROR"
    Case 2301: Msg = "MULTIPLE_INSTANCE_ERROR"
    Case 2302: Msg = "SYSTEM_ITEM_NOT_ALTERABLE"
    Case 2303: Msg = "BAG_CONVERSION_ERROR"
    Case 2304: Msg = "SELECTOR_OUT_OF_RANGE"
    Case 2305: Msg = "SELECTOR_NOT_UNIQUE"
    Case 2306: Msg = "INDEX_NOT_PRESENT"
    Case 2307: Msg = "STRING_ERROR"
    Case 2308: Msg = "ENCODING_NOT_SUPPORTED"
    Case 2309: Msg = "SELECTOR_NOT_PRESENT"
    Case 2310: Msg = "OUT_SELECTOR_ERROR"
    Case 2311: Msg = "STRING_TRUNCATED"
    Case 2312: Msg = "SELECTOR_WRONG_TYPE"
    Case 2313: Msg = "INCONSISTENT_ITEM_TYPE"
    Case 2314: Msg = "INDEX_ERROR"
    Case 2315: Msg = "SYSTEM_BAG_NOT_ALTERABLE"
    Case 2316: Msg = "ITEM_COUNT_ERROR"
    Case 2317: Msg = "FORMAT_NOT_SUPPORTED"
    Case 2318: Msg = "SELECTOR_NOT_SUPPORTED"
    Case 2319: Msg = "ITEM_VALUE_ERROR"
    Case 2320: Msg = "HBAG_ERROR"
    Case 2321: Msg = "PARAMETER_MISSING"
    Case 2322: Msg = "CMD_SERVER_NOT_AVAILABLE"
    Case 2323: Msg = "STRING_LENGTH_ERROR"
    Case 2324: Msg = "INQUIRY_COMMAND_ERROR"
    Case 2325: Msg = "NESTED_BAG_NOT_SUPPORTED"
    Case 2326: Msg = "BAG_WRONG_TYPE"
    Case 2327: Msg = "ITEM_TYPE_ERROR"
    Case 2328: Msg = "SYSTEM_BAG_NOT_DELETABLE"
    Case 2329: Msg = "SYSTEM_ITEM_NOT_DELETABLE"
    Case 2330: Msg = "CODED_CHAR_SET_ID_ERROR"
    Case 2331: Msg = "MSG_TOKEN_ERROR"
    Case 2332: Msg = "MISSING_WIH"
    Case 2333: Msg = "WIH_ERROR"
    Case 2334: Msg = "RFH_ERROR"
    Case 2335: Msg = "RFH_STRING_ERROR"  ' Last in MQ 5.0
    Case 2336: Msg = "RFH_COMMAND_ERROR"
    Case 2337: Msg = "RFH_PARM_ERROR"
    Case 2338: Msg = "RFH_DUPLICATE_PARM"
    Case 2339: Msg = "RFH_PARM_MISSING"  ' Last in MQ 5.1, see also 2187-2190, 2232, 2266-2279
    Case 2340: Msg = "CHAR_CONVERSION_ERROR"
    Case 2341: Msg = "UCS2_CONVERSION_ERROR"
    Case 2342: Msg = "DB2_NOT_AVAILABLE"
    Case 2343: Msg = "OBJECT_NOT_UNIQUE"
    Case 2344: Msg = "CONN_TAG_NOT_RELEASED"
    Case 2345: Msg = "CF_NOT_AVAILABLE"
    Case 2346: Msg = "CF_STRUC_IN_USE"
    Case 2347: Msg = "CF_STRUC_LIST_HDR_IN_USE"
    Case 2348: Msg = "CF_STRUC_AUTH_FAILED"
    Case 2349: Msg = "CF_STRUC_ERROR"
    Case 2350: Msg = "CONN_TAG_NOT_USABLE"
    Case 2351: Msg = "GLOBAL_UOW_CONFLICT"
    Case 2352: Msg = "LOCAL_UOW_CONFLICT"
    Case 2353: Msg = "HANDLE_IN_USE_FOR_UOW"
    Case 2354: Msg = "UOW_ENLISTMENT_ERROR"
    Case 2355: Msg = "UOW_MIX_NOT_SUPPORTED"
    Case 2356: Msg = "WXP_ERROR"
    Case 2357: Msg = "CURRENT_RECORD_ERROR"
    Case 2358: Msg = "NEXT_OFFSET_ERROR"
    Case 2359: Msg = "NO_RECORD_AVAILABLE"
    Case 2360: Msg = "OBJECT_LEVEL_INCOMPATIBLE"
    Case 2361: Msg = "NEXT_RECORD_ERROR"  ' Last in MQ 5.2
    Case 2362: Msg = "BACKOUT_THRESHOLD_REACHED"
    Case 2363: Msg = "MSG_NOT_MATCHED"
    Case 2364: Msg = "JMS_FORMAT_ERROR"
    Case 2365: Msg = "SEGMENTS_NOT_SUPPORTED"
    Case 2366: Msg = "WRONG_CF_LEVEL"
    Case 2367: Msg = "CONFIG_CREATE_OBJECT"
    Case 2368: Msg = "CONFIG_CHANGE_OBJECT"
    Case 2369: Msg = "CONFIG_DELETE_OBJECT"
    Case 2370: Msg = "CONFIG_REFRESH_OBJECT"
    Case 2371: Msg = "CHANNEL_SSL_ERROR"
    Case 2372: Msg = "PARTICIPANT_NOT_DEFINED"   ' 2372 new in MQ 7.0
    Case 2373: Msg = "CF_STRUC_FAILED"
    Case 2374: Msg = "API_EXIT_ERROR"
    Case 2375: Msg = "API_EXIT_INIT_ERROR"
    Case 2376: Msg = "API_EXIT_TERM_ERROR"
    Case 2377: Msg = "EXIT_REASON_ERROR"
    Case 2378: Msg = "RESERVED_VALUE_ERROR"
    Case 2379: Msg = "NO_DATA_AVAILABLE"
    Case 2380: Msg = "SCO_ERROR"
    Case 2381: Msg = "KEY_REPOSITORY_ERROR"
    Case 2382: Msg = "CRYPTO_HARDWARE_ERROR"
    Case 2383: Msg = "AUTH_INFO_REC_COUNT_ERROR"
    Case 2384: Msg = "AUTH_INFO_REC_ERROR"
    Case 2385: Msg = "AIR_ERROR"
    Case 2386: Msg = "AUTH_INFO_TYPE_ERROR"
    Case 2387: Msg = "AUTH_INFO_CONN_NAME_ERROR"
    Case 2388: Msg = "LDAP_USER_NAME_ERROR"
    Case 2389: Msg = "LDAP_USER_NAME_LENGTH_ERR"
    Case 2390: Msg = "LDAP_PASSWORD_ERROR"
    Case 2391: Msg = "SSL_ALREADY_INITIALIZED"
    Case 2392: Msg = "SSL_CONFIG_ERROR"
    Case 2393: Msg = "SSL_INITIALIZATION_ERROR"
    Case 2394: Msg = "Q_INDEX_TYPE_ERROR"
    Case 2395: Msg = "CFBS_ERROR"                 ' 2395 new for MQ 6.0
    Case 2396: Msg = "SSL_NOT_ALLOWED"
    Case 2397: Msg = "JSSE_ERROR"
    Case 2398: Msg = "SSL_PEER_NAME_MISMATCH"
    Case 2399: Msg = "SSL_PEER_NAME_ERROR"
    Case 2400: Msg = "UNSUPPORTED_CIPHER_SUITE"
    Case 2401: Msg = "SSL_CERTIFICATE_REVOKED"
    Case 2402: Msg = "SSL_CERT_STORE_ERROR"  ' Last in MQ 5.3
    '    2403 to 2405 not defined
    Case 2406: Msg = "CLIENT_EXIT_LOAD_ERROR"
    Case 2407: Msg = "CLIENT_EXIT_ERROR"
    Case 2408: Msg = "UOW_COMMITTED"           ' 2408 new in MQ 7.0
    Case 2409: Msg = "SSL_KEY_RESET_ERROR"
    Case 2410: Msg = "UNKNOWN_COMPONENT_NAME"
    Case 2411: Msg = "LOGGER_STATUS"
    Case 2412: Msg = "COMMAND_MQSC"
    Case 2413: Msg = "COMMAND_PCF"
    Case 2414: Msg = "CFIF_ERROR"
    Case 2415: Msg = "CFSF_ERROR"
    Case 2416: Msg = "CFGR_ERROR"
    Case 2417: Msg = "MSG_NOT_ALLOWED_IN_GROUP"
    Case 2418: Msg = "FILTER_OPERATOR_ERROR"
    Case 2419: Msg = "NESTED_SELECTOR_ERROR"
    Case 2420: Msg = "EPH_ERROR"
    Case 2421: Msg = "RFH_FORMAT_ERROR"
    Case 2422: Msg = "CFBF_ERROR"
    Case 2423: Msg = "CLIENT_CHANNEL_CONFLICT"   ' Last in MQ 6.0
    Case 2424: Msg = "SD_ERROR"
    Case 2425: Msg = "TOPIC_STRING_ERROR"
    Case 2426: Msg = "STS_ERROR"
    '    2427 not defined
    Case 2428: Msg = "NO_SUBSCRIPTION"
    Case 2429: Msg = "SUBSCRIPTION_IN_USE"
    Case 2430: Msg = "STAT_TYPE_ERROR"
    Case 2431: Msg = "SUB_USER_DATA_ERROR"
    Case 2432: Msg = "SUB_ALREADY_EXISTS"
    '    2433 not defined
    Case 2434: Msg = "IDENTITY_MISMATCH"
    Case 2435: Msg = "ALTER_SUB_ERROR"
    Case 2436: Msg = "DURABILITY_NOT_ALLOWED"
    Case 2437: Msg = "NO_RETAINED_MSG"
    Case 2438: Msg = "SRO_ERROR"
    '    2439 not defined
    Case 2440: Msg = "SUB_NAME_ERROR"
    Case 2441: Msg = "OBJECT_STRING_ERROR"
    Case 2442: Msg = "PROPERTY_NAME_ERROR"
    Case 2443: Msg = "SEGMENTATION_NOT_ALLOWED"
    Case 2444: Msg = "CBD_ERROR"
    Case 2445: Msg = "CTLO_ERROR"
    Case 2446: Msg = "NO_CALLBACKS_ACTIVE"
    '    2447 not defined
    Case 2448: Msg = "CALLBACK_NOT_REGISTERED"
    '    2449 - 2456 not defined
    Case 2457: Msg = "OPTIONS_CHANGED"
    Case 2458: Msg = "READ_AHEAD_MSGS"
    Case 2459: Msg = "SELECTOR_SYNTAX_ERROR"
    Case 2460: Msg = "HMSG_ERROR"
    Case 2461: Msg = "CMHO_ERROR"
    Case 2462: Msg = "DMHO_ERROR"
    Case 2463: Msg = "SMPO_ERROR"
    Case 2464: Msg = "IMPO_ERROR"
    Case 2465: Msg = "PROPERTY_NAME_TOO_BIG"
    Case 2466: Msg = "PROP_VALUE_NOT_CONVERTED"
    Case 2467: Msg = "PROP_TYPE_NOT_SUPPORTED"
    '    2468 not defined
    Case 2469: Msg = "PROPERTY_VALUE_TOO_BIG"
    Case 2470: Msg = "PROP_CONV_NOT_SUPPORTED"
    Case 2471: Msg = "PROPERTY_NOT_AVAILABLE"
    Case 2472: Msg = "PROP_NUMBER_FORMAT_ERROR"
    Case 2473: Msg = "PROPERTY_TYPE_ERROR"
    '    2474 - 2477 not defined
    Case 2478: Msg = "PROPERTIES_TOO_BIG"
    Case 2479: Msg = "PUT_NOT_RETAINED"
    Case 2480: Msg = "ALIAS_TARGTYPE_CHANGED"
    Case 2481: Msg = "DMPO_ERROR"
    Case 2482: Msg = "PD_ERROR"
    Case 2483: Msg = "CALLBACK_TYPE_ERROR"
    Case 2484: Msg = "CBD_OPTIONS_ERROR"
    Case 2485: Msg = "MAX_MSG_LENGTH_ERROR"
    Case 2486: Msg = "CALLBACK_ROUTINE_ERROR"
    Case 2487: Msg = "CALLBACK_LINK_ERROR"
    Case 2488: Msg = "OPERATION_ERROR"
    Case 2489: Msg = "BMHO_ERROR"
    Case 2490: Msg = "UNSUPPORTED_PROPERTY"
    '    2491 not defined
    Case 2492: Msg = "PROP_NAME_NOT_CONVERTED"
    '    2493 not defined
    Case 2494: Msg = "GET_ENABLED"
    Case 2495: Msg = "MODULE_NOT_FOUND"
    Case 2496: Msg = "MODULE_INVALID"
    Case 2497: Msg = "MODULE_ENTRY_NOT_FOUND"
    Case 2498: Msg = "MIXED_CONTENT_NOT_ALLOWED"
    Case 2499: Msg = "MSG_HANDLE_IN_USE"
    Case 2500: Msg = "HCONN_ASYNC_ACTIVE"
    Case 2501: Msg = "MHBO_ERROR"
    Case 2502: Msg = "PUBLICATION_FAILURE"
    Case 2503: Msg = "SUB_INHIBITED"
    Case 2504: Msg = "SELECTOR_ALWAYS_FALSE"
    '    2505 - 2506 not defined
    Case 2507: Msg = "XEPO_ERROR"
    '    2508 not defined
    Case 2509: Msg = "DURABILITY_NOT_ALTERABLE"
    Case 2500: Msg = "TOPIC_NOT_ALTERABLE"
    '    2511 not defined
    Case 2512: Msg = "SUBLEVEL_NOT_ALTERABLE"
    Case 2513: Msg = "PROPERTY_NAME_LENGTH_ERR"
    Case 2514: Msg = "DUPLICATE_GROUP_SUB"
    Case 2515: Msg = "GROUPING_NOT_ALTERABLE"
    Case 2516: Msg = "SELECTOR_INVALID_FOR_TYPE"
    Case 2517: Msg = "HOBJ_QUIESCED"
    Case 2518: Msg = "HOBJ_QUIESCED_NO_MSGS"
    Case 2519: Msg = "SELECTION_STRING_ERROR"
    Case 2520: Msg = "RES_OBJECT_STRING_ERROR"
    Case 2521: Msg = "CONNECTION_SUSPENDED"
    Case 2522: Msg = "INVALID_DESTINATION"
    Case 2523: Msg = "INVALID_SUBSCRIPTION"
    Case 2524: Msg = "SELECTOR_NOT_ALTERABLE"
    Case 2525: Msg = "RETAINED_MSG_Q_ERROR"
    Case 2526: Msg = "RETAINED_NOT_DELIVERED"
    Case 2527: Msg = "RFH_RESTRICTED_FORMAT_ERR"
    Case 2528: Msg = "CONNECTION_STOPPED"
    Case 2529: Msg = "ASYNC_UOW_CONFLICT"
    Case 2530: Msg = "ASYNC_XA_CONFLICT"
    Case 2531: Msg = "PUBSUB_INHIBITED"
    Case 2532: Msg = "MSG_HANDLE_COPY_FAILURE"
    Case 2533: Msg = "DEST_CLASS_NOT_ALTERABLE"
    Case 2534: Msg = "OPERATION_NOT_ALLOWED"
    Case 2535: Msg = "ACTION_ERROR"
    '    2536 not defined
    Case 2537: Msg = "CHANNEL_NOT_AVAILABLE"
    Case 2538: Msg = "HOST_NOT_AVAILABLE"
    Case 2539: Msg = "CHANNEL_CONFIG_ERROR"
    Case 2540: Msg = "UNKNOWN_CHANNEL_NAME"
    Case 2541: Msg = "LOOPING_PUBLICATION"
    Case 2542: Msg = "ALREADY_JOINED"     ' Last in MQ 7.0

    ' Reason Codes for C++ environment only
    Case 6100: Msg = "REOPEN_EXCL_INPUT_ERROR"
    Case 6101: Msg = "REOPEN_INQUIRE_ERROR"
    Case 6102: Msg = "REOPEN_SAVED_CONTEXT_ERR"
    Case 6103: Msg = "REOPEN_TEMPORARY_Q_ERROR"
    Case 6104: Msg = "ATTRIBUTE_LOCKED"
    Case 6105: Msg = "CURSOR_NOT_VALID"
    Case 6106: Msg = "ENCODING_ERROR"
    Case 6107: Msg = "STRUC_ID_ERROR"
    Case 6108: Msg = "NULL_POINTER"
    Case 6109: Msg = "NO_CONNECTION_REFERENCE"
    Case 6110: Msg = "NO_BUFFER"
    Case 6111: Msg = "BINARY_DATA_LENGTH_ERROR"
    Case 6112: Msg = "BUFFER_NOT_AUTOMATIC"
    Case 6113: Msg = "INSUFFICIENT_BUFFER"
    Case 6114: Msg = "INSUFFICIENT_DATA"
    Case 6115: Msg = "DATA_TRUNCATED"
    Case 6116: Msg = "ZERO_LENGTH"
    Case 6117: Msg = "NEGATIVE_LENGTH"
    Case 6118: Msg = "NEGATIVE_OFFSET"
    Case 6119: Msg = "INCONSISTENT_FORMAT"
    Case 6120: Msg = "INCONSISTENT_OBJECT_STATE"
    Case 6121: Msg = "CONTEXT_OBJECT_NOT_VALID"
    Case 6122: Msg = "CONTEXT_OPEN_ERROR"
    Case 6123: Msg = "STRUC_LENGTH_ERROR"
    Case 6124: Msg = "NOT_CONNECTED"
    Case 6125: Msg = "NOT_OPEN"
    Case 6126: Msg = "DISTRIBUTION_LIST_EMPTY"
    Case 6127: Msg = "INCONSISTENT_OPEN_OPTIONS"
    Case 6128: Msg = "WRONG_VERSION"
    Case 6129: Msg = "REFERENCE_ERROR"  ' Last in MQ 5.2, 5.3, 6.0, 7.0

    Case Else
      BegNumPos = InStr(MoreRc, NUMPFX & Rc & DESCPFX)
      If BegNumPos Then
        BegDescPos = InStr(BegNumPos & 1, MoreRc, DESCPFX) + 1
        EndDescPos = InStr(BegDescPos + 1, MoreRc, NUMPFX)
        If EndDescPos = 0 Then EndDescPos = Len(MoreRc) + 1
        Msg = Mid(MoreRc, BegDescPos, EndDescPos - BegDescPos)
      Else
        Msg = Rc & "_UNDEFINED"
      End If
  End Select

  MQReasonCodeMsg = "MQRC_" & Msg

End Function

