Attribute VB_Name = "CODE"
'
' IBM SupportPac MA0K
' WebSphere MQ Completion Code and Reason Code analysis programs V1.4
' http://www.ibm.com/support/docview.wss?uid=swg24000652
'
' MQMCH "WebSphere MQ Messages and Codes Helper" in Visual Basic 5.0
'
' code3.1.bas  Global declarations and Code module
'
' Source file: \\IBM-L3V1408\MWARE-WMQ\winutils\mqmch-v3.1\code3.1.bas
'
' Version   Date         Name       Changes
'     2.1   01 Sep 1999  Glenn      Initial version, based on PCWIN31\MQMCH\CODE7.BAS for VB 3.0
'                        Baddeley <glenbadd@au1.ibm.com>
'     2.2   13 Sep 1999  GB         Resizable boxes on frmMain
'     2.3   20 Aug 2001  GB         Support MQ 5.2
'     2.4   24 Aug 2001  GB         Use registry rather that ini
'   2.4.1   06 Sep 2001  GB         Use new make data which includes RC 2361
'   2.5.1   19 Oct 2001  GB         Cater for duplicate reason codes (eg. 2192),
'                                   Add DI_VERISON
'   2.6.1   22 Feb 2002  GB         Add PrtFontName, PrtFontSize and PrtMaxWidth variables
'   2.7.1    3 Mar 2002  GB         Remove PrtFont variables
'   2.7.2   28 Jan 2003  GB         Rebrand MQSeries to WebSphere MQ (5.3),
'                                   Increase RESINDEXSIZE from 4200 to 4600
'   2.7.3   28 Jan 2004  GB         Change owner from IBM GSA to IBM Australia
'                                   Change APPKEY from MQSeries to WebSphere MQ
'     3.1    7 Oct 2008  GB         Update for MQ 7.0 GA
'                                   Increase RESINDEXSIZE from 4600 to 4700
'
Private Const SRCID = "@(#)CODE3.1.BAS VER=3.1 DATE=7-Oct-2008"

' <N_OCO_COPYRIGHT>
' Licensed Materials - Property of IBM
' (c) Copyright IBM Corp. 2008 All Rights Reserved.
' US Government Users Restricted Rights - Use, duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
' <NOC_COPYRIGHT>
Private Const CPRID = "@(#)Copyright 2008 IBM Australia"
Private Const OWNID = "@(#)Licensed Materials - Property of IBM"

Option Explicit

' Constants

Global PIXELX As Single     ' Initialised in Main
Global PIXELY As Single     ' "
Global Const DIRSEP = "\"
Global Const EOLMARK = "~"
Global Const FLDSEP = "|"
Global Const NKEYBEG = "["
Global Const NKEYEND = "]"
Global Const BINRESERRPFX = "Binary Resource Error: "
Global Const RESINDEXSIZE = 6200
Global Const APPKEY = "Software\IBM\WebSphere MQ Utilities\Messages and Codes Helper"
Global Const DI_VERSION = 1

' Variables

Global ResExeFile As String
Global ResCacheFile As String
Global DidReformat As Integer
Global DidMake As Integer
Global RunningIde As Boolean
Global DebugFlag As Boolean
Global NumericKeys As String
Global SymbolicKeys As String
Global Edition As String

' Messages structure

Type MessType
    MType As Integer    ' MTYPExx constants
    MValue As Long
    MSymConst As String
    MText As String
End Type

Global Const MTYPENONE = 0   ' Values of MType
Global Const MTYPECC = 1
Global Const MTYPERC = 2
Global Const MTYPEDI = 3

Global MessMax As Integer

Global Mess() As MessType

' Match index list

Global MatchIdxList() As Integer

' Windows NT API declares

Global Const LB_SETTABSTOPS = &H192

' Windows NT API

Declare Function GetTickCount Lib "user32" () As Long
' Note that the lParam is not ByVal and is typed as Any - this is because we'll be passing an array
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Sub Main()

Dim TmpDir As String

' Initialise constants

    PIXELX = Screen.TwipsPerPixelX
    PIXELY = Screen.TwipsPerPixelY

    RunningIde = (InStr(App.EXEName, ".") > 0)  ' eg. Project file name prefix "mqmch3.1"
    If RunningIde Then
        ResExeFile = App.Path & DIRSEP & "mqmch.exe"
    Else
        ResExeFile = App.Path & DIRSEP & App.EXEName & ".exe"
    End If

    TmpDir = Environ("TMP")
    If Len(TmpDir) = 0 Then TmpDir = Environ("TEMP")
    If Len(TmpDir) = 0 Then TmpDir = "C:"
    If Right(TmpDir, 1) <> DIRSEP Then TmpDir = TmpDir & DIRSEP
    ResCacheFile = TmpDir & "mqmch_cache.tmp"

    DidReformat = False
    DidMake = False
    
' Display the main form
    
    frmMain.Show

End Sub

